<!-- boolean value editor -->
<template>
    <div class="container"> 
        <span class="bcaption">
            {{ label }}
        </span>
        <v-switch class="nomargin" dense hide-details v-model="val"></v-switch>
    </div>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
    props: {
        label: {
            type: String,  
            required: true
        },
        value: {
            type: Boolean,  
            required: true
        },
    },

    computed: {
        val: {
            get: function(): boolean { return this.value; },
            set: function(v: boolean): void { 
                // for some reason v-switch changes always when value is set
                //console.log(`bool "${this.label}" changed to ${v} (${typeof(v)}), value is ${this.value}`);
                this.$emit("input", v);
            }
        }
    },

    methods: {
        onChange(): void {
            //this.$emit("input");
        }
    },

    mounted() {
        this.val = this.value;
    }
});
</script>

<style scoped>
.container {
    width: 100%;
    text-align: left;
    padding: 0px;
    margin: 0px;
}
.bcaption {
    color: lightgray;
    display: inline-block;
    text-align: left;
    width: calc(100% - 50px);
    margin: 0px;
    padding: 0px;
    font-size: .75rem;
}

.nomargin {
    display: inline-block;
    margin: 0px;
}
</style>
